var stmComm = {
	onTabSwitch: function (where) {
		var mw = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        if (where != 'current')
			return where;
		else if (prefs.getBoolPref("extensions.stm.openInBlankTab")) {
            if (mw.gBrowser.currentURI.spec == 'about:blank' && !mw.gBrowser.selectedTab.getAttribute("busy"))
                return 'current';
            else {
                // Reuse blank tab
                for(var i = 0; i < mw.gBrowser.browsers.length; i++) {
                    if (mw.gBrowser.getBrowserAtIndex(i).currentURI.spec == 'about:blank' && !mw.gBrowser.mTabs[i].getAttribute("busy")) {
                        // Blank URL exists. Move it to the most right and activate it.
                        mw.gBrowser.moveTabToEnd(mw.gBrowser.selectedTab = mw.gBrowser.mTabs[i]);
                        return 'current';
                    }
                }
            }
        }
        return 'tab';
	},

	openListManager: function() {
		const listURL = "chrome://smalltabmix/content/listmanager.xul";
		var features = "chrome,titlebar,toolbar,centerscreen,modal";
		window.openDialog(listURL, "", features);
	},

	trim: function(s) {
	   if (s) return s.replace(/^\s+/g,"").replace(/\s+$/g,""); else return "";
	},

    startWith: function(s, prefix) {
       if (s) return( (s.substring(0, prefix.length) == prefix) ); else return false;
    },

	listAminusB: function(a, b) {
		var finded;
		var result = new Array();
		for (var i = 0; i < a.length; i++ ) {
			finded = false;
			for (var j = 0; j < b.length; j++ )	{
				if (a[i] == b[j]) {finded = true; break;}
			}
			if (!finded) result.push(a[i]);
		}
		return result;	  
	},

};


		  		 
		  





